/*
  Definirajte funkciju
    int **tablica(int m, int n, int *k)}
  koja alocira dvodimenzionalno polje cijelih brojeva t, dimenzija m x n,
  kao dinamički niz dinamičkih nizova cijelih brojeva (int**).

  Funkcija potom, u svakom od m redaka, sa standardnog ulaza učitava n - 1
  cijelih brojeva, za koje možete pretpostaviti da su različiti od 0,
  a na kraj retka postavlja 0.

  Potrebno je udvostručiti sve retke koji sadrže barem jedan neparan broj. Pod
  udvostručenjem podrazumijevamo izradu novog retka, kopiranog sadržaja, koji se
  umeće u polje neposredno ispred ili iza starog. Retke koji su tako dodani ne
  treba se (i ne smije) ponovno udvostručavati.
  U varijabilni parametar k spremite novi broj redaka.
  Konačno, funkcija vraća polje t

  Napišite i dio koda koji demonstrira poziv funkcije i dealokaciju dobivenog
  polja.




  Napomena: kako bi kod bio pregledniji, pojedini segmenti rjesenja su medusobno
            odvojeni u kodu - ovo nije najkrace niti najefikasnije rjesenje.

            Trazeni dio koda (s kraja zadatka) je u ovoj datoteci napisan u funkciji main.
*/

#include <stdio.h>
#include <stdlib.h>

/* pomocna funkcija (nije ju trebalo pisati) */
void ispis(int **t, int m)
{
  int i, j;
  for (i = 0; i < m; ++i)
  {
    for (j = 0; t[i][j] != 0; ++j)
      printf("%d ", t[i][j]);
    printf("0\n");
  }
}



/* u nastavku je rjesenje zadatka */
int **tablica(int m, int n, int *k)
{
  int i;

  /* alokacija i ucitavanje */
  int **t = (int **)malloc(m * sizeof(int *));
  for (i = 0; i < m; ++i)
  {
    int j;
    t[i] = (int *)malloc(n * sizeof(int));
    for (j = 0; j < n - 1; ++j)
      scanf("%d", &t[i][j]);
    t[i][n - 1] = 0;
  }

  /* za svaki redak: sadrži li neparan broj? ako da, udvostrucujemo ga */
  for (i = 0; i < m; ++i)
  {
    int j, p, uvjet = 0;

    for (j = 0; j < n; ++j)
      if (t[i][j] % 2)
          uvjet = 1;

    if (uvjet)
    {
      ++m;
      t = (int **)realloc(t, m * sizeof(int *));
      for (j = m - 1; j > i; --j) /* premjestamo kasnije redove, da dobijemo prostor */
        t[j] = t[j - 1];
      /* sada t[i] i t[i + 1] pokazuju na istu memoriju, ali u zadatku se trazi odvojena memorija jednakog sadrzaja */
      t[i] = (int *)malloc(n * sizeof(int));  /* nova memorija */
      for (j = 0; j < n; ++j) /* kopiramo stupce */
        t[i][j] = t[i + 1][j];
      ++i; /* ne zelimo opet udvostrucavati i-ti redak */
    }
  }

  *k = m;
  return t;
}

int main(void)
{
  /* trazeni dio koda - poziv i dealokacija (ispisi nisu dio rjesenja) */
  int i, m = 3, n = 3, k;
  int **t = tablica(m, n, &k);
  ispis(t, k);
  printf("%d\n", k);

  for (i = 0; i < k; ++i)
    free(t[i]);
  free(t);
}



