/*
  Definirajte funkciju
    int **tablica(int m, int n, int *k)}
  koja alocira dvodimenzionalno polje cijelih brojeva t, dimenzija m x n,
  kao dinamički niz dinamičkih nizova cijelih brojeva (int**).

  Funkcija potom, u svakom od m redaka, sa standardnog ulaza učitava n - 1
  cijelih brojeva, za koje možete pretpostaviti da su različiti od 0,
  a na kraj retka postavlja 0.

  Potrebno je ``udvostručiti'' (ponoviti) svaku pojavu pozitivnog neparnog broja.
  Primjerice, redak
      -1 | 1 | 2 | 3 | 0
  postaje
      -1 | 1 | 1 | 2 | 3 | 3 | 0,
  a redak
      1 | 1 | 0
  postaje
      1 | 1 | 1 | 1 | 0.
  U varijabilni parametar k spremite sumu (nakon izmjena) svih članova polja t.
  Konačno, funkcija vraća polje t.

  Napišite i dio koda koji demonstrira poziv funkcije i dealokaciju dobivenog
  polja.




  Napomena: kako bi kod bio pregledniji, pojedini segmenti rjesenja su medusobno
            odvojeni u kodu - ovo nije najkrace niti najefikasnije rjesenje.

            Trazeni dio koda (s kraja zadatka) je u ovoj datoteci napisan u funkciji main.
*/

#include <stdio.h>
#include <stdlib.h>

/* pomocna funkcija (nije ju trebalo pisati) */
void ispis(int **t, int m)
{
  int i, j;
  for (i = 0; i < m; ++i)
  {
    for (j = 0; t[i][j] != 0; ++j)
      printf("%d ", t[i][j]);
    printf("0\n");
  }
}



/* u nastavku je rjesenje zadatka */
int **tablica(int m, int n, int *k)
{
  int i;

  /* alokacija i ucitavanje */
  int **t = (int **)malloc(m * sizeof(int *));
  for (i = 0; i < m; ++i)
  {
    int j;
    t[i] = (int *)malloc(n * sizeof(int));
    for (j = 0; j < n - 1; ++j)
      scanf("%d", &t[i][j]);
    t[i][n - 1] = 0;
  }

  /* za svaki redak: trazimo pozitivne neparne brojeve i udvostrucavamo ih */
  for (i = 0; i < m; ++i)
  {
    int j, tn = n; /* tn = broj clanova u trenutnom retku */

    for (j = 0; t[i][j] != 0; ++j)
      if (t[i][j] % 2 == 1) /* nije potrebno pisati t[i][j] > 0, jer za negativne brojeve je ostatak 0 ili negativan */
      {
        int p; /* jos jedan brojac */
        ++tn;
        t[i] = (int *)realloc(t[i], tn * sizeof(int));
        for (p = tn - 1; p > j; --p) /* premjestamo kasnije elemente kako bismo oslobodili prostor za kopiju */
          t[i][p] = t[i][p - 1];     /* kako je posljednja iteracija: t[i][j + 1] = t[i][j + 1 - 1], time smo napravili i trazeno kopiranje */
        ++j; /* za upravo dodani element NE ponavljamo operaciju */
      }
  }

  /* racunanje sume svih clanova (naravno, mogli smo to i ranije) */
  *k = 0;
  for (i = 0; i < m; ++i)
  {
    int j = 0;
    for (j = 0; t[i][j] != 0; ++j)
      *k += t[i][j];
  }

  return t;
}

int main(void)
{
  /* trazeni dio koda - poziv i dealokacija (ispisi nisu dio rjesenja) */
  int i, m = 3, n = 3, k;
  int **t = tablica(m, n, &k);
  ispis(t, m);
  printf("%d\n", k);

  for (i = 0; i < m; ++i)
    free(t[i]);
  free(t);

}



