#include <stdio.h>

  /* Zadatak 4B:
     Napisite funkciju ocisti koja prima zadani string tekst.
     String se sastoji od nula ili vise rijeci. Rijec je najdulji
     uzastopni niz znakova koji ne sadrzi razmak (znak ' '), a
     rijeci su odvojene bar jednim razmakom.

     Znakove '<', '>', '!', '=' smatramo relacijskim znakovima. Kazemo
     da je rijec ``losa'' ako pocinje nekim relacijskim znakom i taj
     znak se nalazi na jos barem dva mjesta. U svim takvim rijecima,
     sve relacijske znakove treba promijeniti u znak '*'.

     Kao vrijednost funkcije treba vratiti broj losih rijeci, a kroz
     varijabilni argument treba vratiti pokazivac na prvi promijenjeni
     znak. Ako takav znak ne postoji, onda treba vratiti NULL.

     Primjer: Rijec "<x=x<x<x" je losa, a ">x<<<x>" i "x!x!x!x!" nisu
     lose. Losa rijec treba postati "*x*x*x*x".

     Napomena: Zabranjeno je koristenje funkcija iz zaglavlja string.h,
     ctype.h.
  */

    /* Provjera je li znak relacijski. */

int relacija(char c)
{
    return c == '<' || c == '>' || c == '!' || c == '=';
}

    /* Nadji indeks kraja rijeci, pocev od indeksa poc.
       Koristi se kad znamo da je tekst[poc] pocetak ili
       dio rijeci, pa je indeks_kraja >= poc.
       U suprotnom, vrati indeks_kraja = poc - 1. */

int indeks_kraja(char *tekst, int poc)
{
    int i = poc;
    while (tekst[i] != '\0' && tekst[i] != ' ') ++i;
    return i - 1;
}

    /* Trazena funkcija iz zadatka. */

int ocisti(char *tekst, char **p_p_prvi)
{
    const char novi_znak = '*';
    int broj_losih = 0;
    char* p_prva_promjena = NULL;

    int i = 0, j, poc, kraj;
    int losa;
    int broj;

      /* Petlja za prolaz po stringu. */
    while (tekst[i] != '\0') {

          /* Preskoci prazninu. */
        if (tekst[i] == ' ') {
            ++i;
            continue;
        }

          /* Pocetak rijeci, zapamti indeks. */
        poc = i;

          /* Nadji indeks kraja te rijeci. */
        kraj = indeks_kraja(tekst, poc);

          /* Provjeri rijec. */
        losa = 0;
        if (relacija(tekst[poc])) {
            broj = 1;
            for (j = poc + 1; j <= kraj; ++j)
                if (relacija(tekst[j]) && tekst[j] == tekst[poc]) {
                    ++broj;
                    if (broj >= 3) {
                        losa = 1;
                        break;
                    }
                }
        }

          /* Postavi indeks i iza zadnjeg znaka rijeci. */
        i = kraj + 1;
        if (!losa) continue;

          /* Losa rijec, promijeni ju. */
        ++broj_losih;
        for (j = poc; j <= kraj; ++j)
            if (relacija(tekst[j])) {
                  /* Promijeni znak. */
                tekst[j] = novi_znak;
                  /* Azuriraj pokazivac prve promjene. */
                if (p_prva_promjena == NULL)
                    p_prva_promjena = &tekst[j];
            }

    }

      /* Vrati zadane vrijednosti. */
    *p_p_prvi = p_prva_promjena;
    return broj_losih;
}

    /* Glavni program za demostraciju rada funkcije. */

int main(void) {
        /* Primjer stringa. */
    char tekst[] = "  >x<<<x> <x=x<x<x x!x!x!x!" ;

    int broj_losih, ind;
    char *ptr_prva_promjena;

        /* Pocetno stanje stringa. */
    printf("Pocetni string:\n%s\n", tekst);

        /* Poziv funkcije. */
    broj_losih = ocisti(tekst, &ptr_prva_promjena);

        /* Ispis rezultata. */
    printf("\nBroj losih rijeci = %d\n", broj_losih);

    if (broj_losih > 0) {
          /* Razlika pokazivaca. */
        ind = (int) (ptr_prva_promjena - tekst);
        printf("Indeks prve promjene = %d\n", ind);
    }

        /* Zavrsno stanje stringa. */
    printf("Zavrsni string:\n%s\n", tekst);

    return 0;
}
