#include <stdio.h>

  /* Zadatak 4D:
     Napisite funkciju uljepsaj koja prima zadani string tekst.
     String se sastoji od nula ili vise rijeci. Rijec je najdulji
     uzastopni niz znakova koji ne sadrzi razmak (znak ' '), a
     rijeci su odvojene bar jednim razmakom.

     Znakove ':', '.', '!', '?' smatramo interpunkcijskim znakovima.
     Kazemo da je rijec ``losa'' ako se u njoj nalaze barem dva
     razlicita interpunkcijska znaka. U svim takvim rijecima, sve
     interpunkcijske znakove treba promijeniti u znak '%'.

     Kao vrijednost funkcije treba vratiti broj losih rijeci, a kroz
     varijabilni argument treba vratiti pokazivac na zadnji promijenjeni
     znak. Ako takav znak ne postoji, onda treba vratiti NULL.

     Primjer: Rijec "x.x:x" je losa, a "..x.x.x.x" nije losa.
     Losa rijec treba postati "x%x%x".

     Napomena: Zabranjeno je koristenje funkcija iz zaglavlja string.h,
     ctype.h.
  */

    /* Provjera je li znak interpunkcijski. */

int interpunk(char c)
{
    return c == ':' || c == '.' || c == '!' || c == '?';
}

    /* Nadji indeks kraja rijeci, pocev od indeksa poc.
       Koristi se kad znamo da je tekst[poc] pocetak ili
       dio rijeci, pa je indeks_kraja >= poc.
       U suprotnom, vrati indeks_kraja = poc - 1. */

int indeks_kraja(char *tekst, int poc)
{
    int i = poc;
    while (tekst[i] != '\0' && tekst[i] != ' ') ++i;
    return i - 1;
}

    /* Trazena funkcija iz zadatka. */

int uljepsaj(char *tekst, char **p_p_zadnji)
{
    const char novi_znak = '%';
    int broj_losih = 0;
    char* p_zadnja_promjena = NULL;

    int i = 0, j, poc, kraj;
    int losa;
    char prvi_interpunk;

      /* Petlja za prolaz po stringu. */
    while (tekst[i] != '\0') {

          /* Preskoci prazninu. */
        if (tekst[i] == ' ') {
            ++i;
            continue;
        }

          /* Pocetak rijeci, zapamti indeks. */
        poc = i;

          /* Nadji indeks kraja te rijeci. */
        kraj = indeks_kraja(tekst, poc);

          /* Provjeri rijec. */
        losa = 0;
        prvi_interpunk = ' ';    // Jos ga nema.
        for (j = poc; j <= kraj; ++j)
            if (interpunk(tekst[j])) {
                if (prvi_interpunk == ' ')
                    prvi_interpunk = tekst[j];    // Zapamti prvi.
                else if (tekst[j] != prvi_interpunk) {
                    losa = 1;
                    break;
                }
            }

          /* Postavi indeks i iza zadnjeg znaka rijeci. */
        i = kraj + 1;
        if (!losa) continue;

          /* Losa rijec, promijeni ju. */
        ++broj_losih;
        for (j = poc; j <= kraj; ++j)
            if (interpunk(tekst[j])) {
                  /* Promijeni znak. */
                tekst[j] = novi_znak;
                  /* Azuriraj pokazivac zadnje promjene. */
                p_zadnja_promjena = &tekst[j];
            }

    }

      /* Vrati zadane vrijednosti. */
    *p_p_zadnji = p_zadnja_promjena;
    return broj_losih;
}

    /* Glavni program za demostraciju rada funkcije. */

int main(void) {
        /* Primjer stringa. */
    char tekst[] = "  x.x:x ..x.x.x.x" ;

    int broj_losih, ind;
    char *ptr_zadnja_promjena;

        /* Pocetno stanje stringa. */
    printf("Pocetni string:\n%s\n", tekst);

        /* Poziv funkcije. */
    broj_losih = uljepsaj(tekst, &ptr_zadnja_promjena);

        /* Ispis rezultata. */
    printf("\nBroj losih rijeci = %d\n", broj_losih);

    if (broj_losih > 0) {
          /* Razlika pokazivaca. */
        ind = (int) (ptr_zadnja_promjena - tekst);
        printf("Indeks zadnje promjene = %d\n", ind);
    }

        /* Zavrsno stanje stringa. */
    printf("Zavrsni string:\n%s\n", tekst);

    return 0;
}
